diff -u default/lines construction/lines
--- default/lines	2009-12-25 15:54:42.000000000 +0100
+++ construction/lines	2009-12-25 21:21:55.000000000 +0100
@@ -61,33 +61,33 @@
 junction=roundabout [0x0c road_class=0 road_speed=1 resolution 21]
 
 # Ways sorted roughly by descending order of class
-highway=motorway {add oneway = yes; add bicycle = no; add foot = no } [0x01 road_class=4 road_speed=7 resolution 14]
-highway=motorway_link {add oneway = yes; add bicycle = no; add foot = no } [0x09 road_class=3 road_speed=2 resolution 16]
-highway=trunk  {add bicycle = no; add foot = no} [0x02 road_class=4 road_speed=5 resolution 16]
-highway=trunk_link {add bicycle = no; add foot = no} [0x09 road_class=3 road_speed=2 resolution 18]
-highway=* & motorroad=yes {add bicycle = no; add foot = no} [0x02 road_class=4 road_speed=4 resolution 16]
-highway=primary [0x03 road_class=3 road_speed=4 resolution 19]
-highway=primary_link [0x08 road_class=3 road_speed=1 resolution 19]
-highway=secondary [0x04 road_class=2 road_speed=3 resolution 20]
-highway=secondary_link [0x08 road_class=2 road_speed=1 resolution 20]
-highway=tertiary [0x05 road_class=1 road_speed=3 resolution 20]
-highway=tertiary_link [0x08 road_class=1 road_speed=1 resolution 20]
-highway=minor [0x06 road_class=1 road_speed=3 resolution 21]
-highway=unclassified [0x06 road_class=0 road_speed=3 resolution 21]
-
-highway=pedestrian & area!=yes {add access = no; add foot = yes} [0x06 road_class=0 road_speed=0 resolution 22]
-highway=living_street [0x06 road_class=0 road_speed=1 resolution 22]
-highway=residential [0x06 road_class=0 road_speed=2 resolution 22]
-highway=bridleway {add access = no; add bicycle = yes; add foot = yes} [0x16 road_class=0 road_speed=0 resolution 23]
-highway=byway [0x16 road_class=0 road_speed=0 resolution 23]
-highway=service [0x07 road_class=0 road_speed=2 resolution 22]
-highway=cycleway {add access = no; add bicycle = yes; add foot = yes} [0x16 road_class=0 road_speed=1 resolution 23]
-highway=footway {add access = no; add foot = yes} [0x16 road_class=0 road_speed=0 resolution 23]
-highway=path {add access = no; add bicycle = yes; add foot = yes} [0x16 road_class=0 road_speed=1 resolution 23]
-highway=steps {add access = no; add foot = yes} [0x16 road_class=0 road_speed=0 resolution 23]
-highway=track [0x0a road_class=0 road_speed=1 resolution 21]
-highway=unsurfaced [0x0a road_class=0 road_speed=1 resolution 21]
-highway=road [0x06 road_class=0 road_speed=1 resolution 21]
+highway=motorway & construction!=yes {add oneway = yes; add bicycle = no; add foot = no } [0x01 road_class=4 road_speed=7 resolution 14]
+highway=motorway_link & construction!=yes {add oneway = yes; add bicycle = no; add foot = no } [0x09 road_class=3 road_speed=2 resolution 16]
+highway=trunk & construction!=yes {add bicycle = no; add foot = no} [0x02 road_class=4 road_speed=5 resolution 16]
+highway=trunk_link & construction!=yes {add bicycle = no; add foot = no} [0x09 road_class=3 road_speed=2 resolution 18]
+highway=* & motorroad=yes & construction!=yes {add bicycle = no; add foot = no} [0x02 road_class=4 road_speed=4 resolution 16]
+highway=primary & construction!=yes [0x03 road_class=3 road_speed=4 resolution 19]
+highway=primary_link & construction!=yes [0x08 road_class=3 road_speed=1 resolution 19]
+highway=secondary & construction!=yes [0x04 road_class=2 road_speed=3 resolution 20]
+highway=secondary_link & construction!=yes [0x08 road_class=2 road_speed=1 resolution 20]
+highway=tertiary & construction!=yes [0x05 road_class=1 road_speed=3 resolution 20]
+highway=tertiary_link & construction!=yes [0x08 road_class=1 road_speed=1 resolution 20]
+highway=minor & construction!=yes [0x06 road_class=1 road_speed=3 resolution 21]
+highway=unclassified & construction!=yes [0x06 road_class=0 road_speed=3 resolution 21]
+
+highway=pedestrian & construction!=yes & area!=yes {add access = no; add foot = yes} [0x06 road_class=0 road_speed=0 resolution 22]
+highway=living_street & construction!=yes [0x06 road_class=0 road_speed=1 resolution 22]
+highway=residential & construction!=yes [0x06 road_class=0 road_speed=2 resolution 22]
+highway=bridleway & construction!=yes {add access = no; add bicycle = yes; add foot = yes} [0x16 road_class=0 road_speed=0 resolution 23]
+highway=byway & construction!=yes [0x16 road_class=0 road_speed=0 resolution 23]
+highway=service & construction!=yes [0x07 road_class=0 road_speed=2 resolution 22]
+highway=cycleway & construction!=yes {add access = no; add bicycle = yes; add foot = yes} [0x16 road_class=0 road_speed=1 resolution 23]
+highway=footway & construction!=yes {add access = no; add foot = yes} [0x16 road_class=0 road_speed=0 resolution 23]
+highway=path & construction!=yes {add access = no; add bicycle = yes; add foot = yes} [0x16 road_class=0 road_speed=1 resolution 23]
+highway=steps & construction!=yes {add access = no; add foot = yes} [0x16 road_class=0 road_speed=0 resolution 23]
+highway=track & construction!=yes [0x0a road_class=0 road_speed=1 resolution 21]
+highway=unsurfaced & construction!=yes [0x0a road_class=0 road_speed=1 resolution 21]
+highway=road & construction!=yes [0x06 road_class=0 road_speed=1 resolution 21]
 
 # Mop up any unrecognised highway types
 highway=* & highway!=construction & area!=yes [0x07 ]
Gemeinsame Unterverzeichnisse: default/.svn und construction/.svn.